/*
 * Author: 秋风悲画扇 <wxstones@gmail.com>
 * date: 2018/03/19
 */

var hexcase = 0; /* hex output format. 0 - lowercase; 1 - uppercase     */
var b64pad = ""; /* base-64 pad character. "=" for strict RFC compliance  */
var chrsz = 8; /* bits per input character. 8 - ASCII; 16 - Unicode    */



function hex_sha1(s) {
	return binb2hex(core_sha1(str2binb(s), s.length * chrsz));
}

function b64_sha1(s) {
	return binb2b64(core_sha1(str2binb(s), s.length * chrsz));
}

function str_sha1(s) {
	return binb2str(core_sha1(str2binb(s), s.length * chrsz));
}

function hex_hmac_sha1(key, data) {
	return binb2hex(core_hmac_sha1(key, data));
}

function b64_hmac_sha1(key, data) {
	return binb2b64(core_hmac_sha1(key, data));
}

function str_hmac_sha1(key, data) {
	return binb2str(core_hmac_sha1(key, data));
}

function random_strmin(range){
	var str = "",
        arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

    for(var i=0; i<range; i++){
        pos = Math.round(Math.random() * (arr.length-1));
        str += arr[pos];
    }
    return str;
}

/**
 * 获取随机字符串
 * @param Min
 * @param Max
 * @returns {*}
 * @constructor
 */
function RandomNum(Min,Max){
    var Range = Max - Min;
    var Rand = Math.random();
    var num = Min + Math.round(Rand * Range);
    return num;
}

/**
 * 加密方法名
 */
function set_mixing(action){
	/** 打散字符串 */
    var _list = action.split("");
    var _nums = RandomNum(1,5);
    /** 获取地址密码 */
	var _data = get_letter(_nums);
	/** 获取方法名位置串 */
	var _acons = _nums;
	/** 循环方法名 */
	for(var i=0;i < _list.length;i++){
		/** 循环字典 */
		for(var y=0;y< _data.length;y++){
			if(_list[i] === _data[y]){
                _acons += "_" + y ;
                break;
			}
		}
	}
	return _acons;
}

/**
 * 加密地址串
 * @param letter
 * @returns {*}
 */
function get_letter(letter){
	if(letter){
		var letter_s = ['m','n','b','q','e','r','f','g','j','k','z','c','v','t','u','a','s','w','y','o','l','p','d','h','i','x','_'];
		switch(letter){
			/** 顺序 */
			case 1:
				letter_s.sort();
				break;
			/** 倒序 */
			case 2:
                letter_s.sort().reverse();
				break;
			/** 乱序 */
			case 3:
                letter_s = ['r','m','b','e','f','g','q','n','k','z','v','t','a','o','l','c','s','w','y','p','d','h','i','_','u','x','j'];
				break;
			/** 默认序 */
			default :
                letter_s = ['m','n','b','q','e','r','f','g','j','k','z','c','v','t','u','a','s','w','y','o','l','p','d','h','i','x','_'];
		}
		return letter_s;
	}else{
		return false;
	}
}


/**
 * 加密排序
 * @param object
 * @param crypt
 * @returns {*}
 */
function sort_token(object,crypt){
    var _list		=	Object.keys(object).sort();
    var sign		=	"";
    for (var i in _list) {
        sign += _list[i] + "=" + object[_list[i]] + "&";
    }
    sign			=	crypt + '*' + sign.substr(0, sign.length - 1) + '*' + crypt;
    return hex_sha1(sign);
}

/**
 * js 数组合并
 * @param jsonbject1
 * @param jsonbject2
 * @returns {{}}
 */
function json_merge(jsonbject1,jsonbject2) {
    var resultJsonObject={};
    for(var attr in jsonbject1){
        resultJsonObject[attr]=jsonbject1[attr];
    }
    for(var attr in jsonbject2){
        resultJsonObject[attr]=jsonbject2[attr];
    }
    return resultJsonObject;
}

/**
 * 接口加密
 * @param token
 * @param crypt
 * @returns {{token: string, noncestr, timestamp: *}}
 */
function api_token(token,crypt){
	var noncestr	=	random_strmin(32);
	var times		=	new Date().getTime() + "1";
	times			=	times.substr(0, times.length - 4);
	var object      =   {"token":token,"noncestr":noncestr,"timestamp":parseInt(times),"crypt":crypt};
    object['sign']	=	sort_token(object,crypt);
    delete object.crypt;
	return object;
}



/*
 * Perform a simple self-test to see if the VM is working
 */

function sha1_vm_test() {
	return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */

function core_sha1(x, len) { /* append padding */
	x[len >> 5] |= 0x80 << (24 - len % 32);
	x[((len + 64 >> 9) << 4) + 15] = len;
	var w = Array(80);
	var a = 1732584193;
	var b = -271733879;
	var c = -1732584194;
	var d = 271733878;
	var e = -1009589776;
	for (var i = 0; i < x.length; i += 16) {
		var olda = a;
		var oldb = b;
		var oldc = c;
		var oldd = d;
		var olde = e;
		for (var j = 0; j < 80; j++) {
			if (j < 16) w[j] = x[i + j];
			else w[j] = rol(w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16], 1);
			var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)), safe_add(safe_add(e, w[j]), sha1_kt(j)));
			e = d;
			d = c;
			c = rol(b, 30);
			b = a;
			a = t;
		}
		a = safe_add(a, olda);
		b = safe_add(b, oldb);
		c = safe_add(c, oldc);
		d = safe_add(d, oldd);
		e = safe_add(e, olde);
	}
	return Array(a, b, c, d, e);
}
/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */

function sha1_ft(t, b, c, d) {
	if (t < 20) return (b & c) | ((~b) & d);
	if (t < 40) return b ^ c ^ d;
	if (t < 60) return (b & c) | (b & d) | (c & d);
	return b ^ c ^ d;
}
/*
 * Determine the appropriate additive constant for the current iteration
 */

function sha1_kt(t) {
	return (t < 20) ? 1518500249 : (t < 40) ? 1859775393 : (t < 60) ? -1894007588 : -899497514;
}
/*
 * Calculate the HMAC-SHA1 of a key and some data
 */

function core_hmac_sha1(key, data) {
	var bkey = str2binb(key);
	if (bkey.length > 16) bkey = core_sha1(bkey, key.length * chrsz);
	var ipad = Array(16),
		opad = Array(16);
	for (var i = 0; i < 16; i++) {
		ipad[i] = bkey[i] ^ 0x36363636;
		opad[i] = bkey[i] ^ 0x5C5C5C5C;
	}
	var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
	return core_sha1(opad.concat(hash), 512 + 160);
}
/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */

function safe_add(x, y) {
	var lsw = (x & 0xFFFF) + (y & 0xFFFF);
	var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
	return (msw << 16) | (lsw & 0xFFFF);
}
/*
 * Bitwise rotate a 32-bit number to the left.
 */

function rol(num, cnt) {
	return (num << cnt) | (num >>> (32 - cnt));
}
/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */

function str2binb(str) {
	var bin = Array();
	var mask = (1 << chrsz) - 1;
	for (var i = 0; i < str.length * chrsz; i += chrsz)
	bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (24 - i % 32);
	return bin;
}
/*
 * Convert an array of big-endian words to a string
 */

function binb2str(bin) {
	var str = "";
	var mask = (1 << chrsz) - 1;
	for (var i = 0; i < bin.length * 32; i += chrsz)
	str += String.fromCharCode((bin[i >> 5] >>> (24 - i % 32)) & mask);
	return str;
}
/*
 * Convert an array of big-endian words to a hex string.
 */

function binb2hex(binarray) {
	var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
	var str = "";
	for (var i = 0; i < binarray.length * 4; i++) {
		str += hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8 + 4)) & 0xF) + hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8)) & 0xF);
	}
	return str;
}
/*
 * Convert an array of big-endian words to a base-64 string
 */

function binb2b64(binarray) {
	var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	var str = "";
	for (var i = 0; i < binarray.length * 4; i += 3) {
		var triplet = (((binarray[i >> 2] >> 8 * (3 - i % 4)) & 0xFF) << 16) | (((binarray[i + 1 >> 2] >> 8 * (3 - (i + 1) % 4)) & 0xFF) << 8) | ((binarray[i + 2 >> 2] >> 8 * (3 - (i + 2) % 4)) & 0xFF);
		for (var j = 0; j < 4; j++) {
			if (i * 8 + j * 6 > binarray.length * 32) str += b64pad;
			else str += tab.charAt((triplet >> 6 * (3 - j)) & 0x3F);
		}
	}
	return str;
}
